(ns recordbug.workaround)

(defmacro defrecord*
  "Like defrecord but defines a clojure-native map constructor map=>TypeName."
  [name fields & opts+specs]
  (let [classname (str (namespace-munge *ns*) "." name)
        mconsname (symbol (str 'map=> name))
        mkeys     (mapv keyword fields)]
    `(do
       (declare ~mconsname)
       (defrecord ~name [~@fields]
         ~@opts+specs)
       (defn ~mconsname
         ~(str "Factory function (in clojure) for " classname ", taking a map of keywords to field values.")
         [m#]
         (let [args# (map #(get m# (keyword %) nil) ~mkeys)
               anew# (fn [~@fields] (new ~name ~@fields))]
           (apply anew# args#))))))


